/*
 * OboPanel.java
 *
 * Created on 2006/04/13, 15:55
 */

package cytoscape.data.servers.ui;

import java.awt.event.ActionListener;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;

import javax.swing.event.HyperlinkEvent;

import cytoscape.util.CyFileFilter;
import cytoscape.util.FileUtil;
import cytoscape.util.OpenBrowser;

/**
 * 
 * @author kono
 */
public class OboPanel extends javax.swing.JPanel {

	private static final String defaultOboSource = "http://www.geneontology.org/ontology/gene_ontology.obo";
	
	private final String LS = System.getProperty("line.separator");
	private File oboFile;

	/** Creates new OboPanel */
	public OboPanel() {
		initComponents();
	}

	/**
	 * This method is called from within the constructor to initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is always
	 * regenerated by the Form Editor.
	 */
	// <editor-fold defaultstate="collapsed" desc=" Generated Code ">
	private void initComponents() {

		String message = "<html><body>Please select an ontology data file "
				+ "in <a href=\"http://www.geneontology.org/GO.downloads.shtml#ont\">"
				+ "OBO format</a>:</body></html>";

		oboFileNameTextField = new javax.swing.JTextField();
		selectButton = new javax.swing.JButton();
		jSeparator1 = new javax.swing.JSeparator();
		titleLabel = new javax.swing.JLabel();
		headerScrollPane1 = new javax.swing.JScrollPane();
		headerEditorPane = new javax.swing.JEditorPane();
		messageScrollPane = new javax.swing.JScrollPane();
		messageEditorPane = new javax.swing.JEditorPane("text/html", message);

		oboFileNameTextField
				.setToolTipText("Select or type local OBO file name...");
		oboFileNameTextField.setBorder(javax.swing.BorderFactory
				.createTitledBorder(null, "OBO File",
						javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
						javax.swing.border.TitledBorder.DEFAULT_POSITION,
						new java.awt.Font("Serif", 1, 10)));
		oboFileNameTextField
				.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
					public void propertyChange(
							java.beans.PropertyChangeEvent evt) {
						oboFileNameTextFieldPropertyChange(evt);
					}
				});
		oboFileNameTextField
				.addActionListener(new java.awt.event.ActionListener() {
					public void actionPerformed(java.awt.event.ActionEvent evt) {
						oboFileNameTextFieldActionPerformed(evt);
					}
				});
		selectButton.setText("Select");
		selectButton.setActionCommand("selectOboButton");
		selectButton.setMargin(new java.awt.Insets(2, 2, 2, 2));

		titleLabel.setFont(new java.awt.Font("Serif", 1, 14));
		titleLabel.setText("Select Ontology File");

		headerScrollPane1.setBorder(javax.swing.BorderFactory
				.createTitledBorder("Header Preview"));
		headerEditorPane.setEditable(false);
		headerScrollPane1.setViewportView(headerEditorPane);

		messageScrollPane.setBorder(null);
		messageEditorPane.setBackground(new java.awt.Color(204, 204, 204));
		messageEditorPane.setBorder(null);
		messageEditorPane.setEditable(false);
		messageEditorPane.setFont(new java.awt.Font("Serif", 1, 12));

		messageEditorPane
				.setToolTipText("Click hyperlink to visit GO web site...");
		messageEditorPane
				.addHyperlinkListener(new javax.swing.event.HyperlinkListener() {
					public void hyperlinkUpdate(
							javax.swing.event.HyperlinkEvent evt) {
						messageEditorPaneHyperlinkUpdate(evt);
					}
				});

		messageScrollPane.setViewportView(messageEditorPane);

		org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(
				this);
		this.setLayout(layout);
		layout
				.setHorizontalGroup(layout
						.createParallelGroup(
								org.jdesktop.layout.GroupLayout.LEADING)
						.add(
								layout
										.createSequentialGroup()
										.addContainerGap()
										.add(
												layout
														.createParallelGroup(
																org.jdesktop.layout.GroupLayout.LEADING)
														.add(
																jSeparator1,
																org.jdesktop.layout.GroupLayout.DEFAULT_SIZE,
																325,
																Short.MAX_VALUE)
														.add(
																titleLabel,
																org.jdesktop.layout.GroupLayout.DEFAULT_SIZE,
																325,
																Short.MAX_VALUE)
														.add(
																org.jdesktop.layout.GroupLayout.TRAILING,
																messageScrollPane)
														.add(
																oboFileNameTextField,
																org.jdesktop.layout.GroupLayout.DEFAULT_SIZE,
																325,
																Short.MAX_VALUE)
														.add(
																org.jdesktop.layout.GroupLayout.TRAILING,
																headerScrollPane1,
																org.jdesktop.layout.GroupLayout.DEFAULT_SIZE,
																325,
																Short.MAX_VALUE)
														.add(
																org.jdesktop.layout.GroupLayout.TRAILING,
																selectButton,
																org.jdesktop.layout.GroupLayout.PREFERRED_SIZE,
																96,
																org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
										.addContainerGap()));
		layout.setVerticalGroup(layout.createParallelGroup(
				org.jdesktop.layout.GroupLayout.LEADING).add(
				layout.createSequentialGroup().addContainerGap()
						.add(titleLabel).addPreferredGap(
								org.jdesktop.layout.LayoutStyle.RELATED).add(
								jSeparator1,
								org.jdesktop.layout.GroupLayout.PREFERRED_SIZE,
								org.jdesktop.layout.GroupLayout.DEFAULT_SIZE,
								org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
						.addPreferredGap(
								org.jdesktop.layout.LayoutStyle.RELATED).add(
								messageScrollPane,
								org.jdesktop.layout.GroupLayout.PREFERRED_SIZE,
								org.jdesktop.layout.GroupLayout.DEFAULT_SIZE,
								org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
						.addPreferredGap(
								org.jdesktop.layout.LayoutStyle.RELATED).add(
								oboFileNameTextField,
								org.jdesktop.layout.GroupLayout.PREFERRED_SIZE,
								org.jdesktop.layout.GroupLayout.DEFAULT_SIZE,
								org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
						.addPreferredGap(
								org.jdesktop.layout.LayoutStyle.RELATED).add(
								headerScrollPane1,
								org.jdesktop.layout.GroupLayout.DEFAULT_SIZE,
								122, Short.MAX_VALUE).addPreferredGap(
								org.jdesktop.layout.LayoutStyle.RELATED).add(
								selectButton).addContainerGap()));
	}// </editor-fold>

	private void messageEditorPaneHyperlinkUpdate(
			javax.swing.event.HyperlinkEvent evt) {
		// TODO add your handling code here:

		if (evt.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
			OpenBrowser.openURL(evt.getURL().toString());
		}
	}

	protected void selectButtonActionPerformed() {
		// TODO add your handling code here:
		CyFileFilter oboFilter = new CyFileFilter();
		oboFilter.addExtension("obo");
		oboFilter.setDescription("OBO files");

		// Get the file name
		File originalFile = oboFile;
		oboFile = FileUtil.getFile("Import OBO File", FileUtil.LOAD,
				new CyFileFilter[] { oboFilter });

		if (oboFile != null && oboFile.canRead() == true) {
			this.oboFileNameTextField.setText(oboFile.getAbsolutePath());
			this.oboFileNameTextField.setToolTipText(oboFile.getAbsolutePath());

			try {
				BufferedReader br = new BufferedReader(new FileReader(oboFile));
				headerEditorPane.setText(getHeader(br));
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

		} else if (originalFile == null || originalFile.canRead() == false) {
			if (oboFile != null) {
				oboFileNameTextField.setText(oboFile.getAbsolutePath());
			}
			headerEditorPane.setText("This is not a valid OBO file!!");
		}
	}

	private void oboFileNameTextFieldPropertyChange(
			java.beans.PropertyChangeEvent evt) {
		// TODO add your handling code here:

	}

	private void oboFileNameTextFieldActionPerformed(
			java.awt.event.ActionEvent evt) {
		// TODO add your handling code here:
		System.out.println("VC!!!");
	}

	private String getHeader(BufferedReader br) throws IOException {
		String line;
		String header = "";

		while ((line = br.readLine()) != null) {
			if (!(line.startsWith("[Term]"))) {
				header = header + line + LS;
			} else {
				break;
			}
		}

		return header.trim();
	}

	protected File getOboFile() {
		return oboFile;
	}

	protected void setOboFileName(String text) {
		oboFileNameTextField.setText(text);
	}

	protected void setPreviewPane(String text) {
		messageEditorPane.setText(text);
	}

	protected void addButtonActionListener(ActionListener l) {
		selectButton.addActionListener(l);
	}

	// Variables declaration - do not modify
	private javax.swing.JEditorPane headerEditorPane;
	private javax.swing.JScrollPane headerScrollPane1;
	private javax.swing.JSeparator jSeparator1;
	private javax.swing.JEditorPane messageEditorPane;
	private javax.swing.JScrollPane messageScrollPane;
	private javax.swing.JTextField oboFileNameTextField;
	private javax.swing.JButton selectButton;
	private javax.swing.JLabel titleLabel;
	// End of variables declaration

}
